#ifndef __sockrpc_HXX
#include "sockrpc.hxx"
#endif

#ifndef __callbackclient_svc_HXX
#define __callbackclient_svc_HXX

//  YOODA : Yet another Object Oriented Database
//    Copyright (C) 1994  Eric Abecassis

// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.

// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Library General Public License for more details.

// You should have received a copy of the GNU Library General Public
// License along with this library; if not, write to the Free
// Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. 

#ifdef __GNUG__
#pragma interface
#endif

class CallbackClient : public SvcServer {
  public :
  CallbackClient(int family=AF_INET) : SvcServer("CallbackClient", family) {};
  CallbackClient(char* n, int f) : SvcServer(n,f) {}

  public :
  void kill() ;
  void reset() ;
  void keepLock(const ListVal<PID>& l) ;
  int askLock(const PID& pid) ;

  public :

  class ReqRegister_kill {
    public :
    int dummy ;
    ReqRegister_kill(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(CallbackClient::svc_kill,0);
    } 
  } req_kill ;
  static void svc_kill(SvcSocket& __svc) {
    ( ((CallbackClient*)(&__svc))->kill() );
  } ;

  class ReqRegister_reset {
    public :
    int dummy ;
    ReqRegister_reset(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(CallbackClient::svc_reset,1);
    } 
  } req_reset ;
  static void svc_reset(SvcSocket& __svc) {
    ( ((CallbackClient*)(&__svc))->reset() );
  } ;

  class ReqRegister_keepLock {
    public :
    int dummy ;
    ReqRegister_keepLock(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(CallbackClient::svc_keepLock,2);
    } 
  } req_keepLock ;
  static void svc_keepLock(SvcSocket& __svc) {
    ListVal<PID> l ;
    __svc >> l ;
    ( ((CallbackClient*)(&__svc))->keepLock(l) );
  } ;

  class ReqRegister_askLock {
    public :
    int dummy ;
    ReqRegister_askLock(SvcServer* svc = SvcServer::_svcBase) {
      svc->reqRegister(CallbackClient::svc_askLock,3);
    } 
  } req_askLock ;
  static void svc_askLock(SvcSocket& __svc) {
    PID pid ;
    __svc >> pid ;
    __svc << ( ((CallbackClient*)(&__svc))->askLock(pid) ) << svcflush ;
  } ;
} ;


#endif
